@extends ('layouts.patient')

@section('inner-content')

    <?php
    $palette = [
        ["bc" => '#522e92', "fc" => "#fff"],
        ["bc" => '#003152', "fc" => "#fff"],
        ["bc" => '#111e6c', "fc" => "#fff"],
        ["bc" => '#1034a6', "fc" => "#fff"],
        ["bc" => '#0f52ba', "fc" => "#fff"],
        ["bc" => '#447684', "fc" => "#fff"],
        ["bc" => '#d86700', "fc" => "#fff"],
        ["bc" => '#643c07', "fc" => "#fff"],
        ["bc" => '#ff3f3f', "fc" => "#fff"],
        ["bc" => '#ffa395', "fc" => "#222"],
        ["bc" => '#6450ff', "fc" => "#fff"],
        ["bc" => '#8ec7f4', "fc" => "#222"],
        ["bc" => '#522e92', "fc" => "#fff"],
        ["bc" => '#111e6c', "fc" => "#fff"],
        ["bc" => '#003152', "fc" => "#fff"],
        ["bc" => '#1034a6', "fc" => "#fff"],
        ["bc" => '#0f52ba', "fc" => "#fff"],
        ["bc" => '#447684', "fc" => "#fff"],
        ["bc" => '#d86700', "fc" => "#fff"],
        ["bc" => '#643c07', "fc" => "#fff"],
        ["bc" => '#ff3f3f', "fc" => "#fff"],
        ["bc" => '#ffa395', "fc" => "#222"],
        ["bc" => '#6450ff', "fc" => "#fff"],
        ["bc" => '#8ec7f4', "fc" => "#222"],
    ];
    ?>

    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet" />
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>
    <link href='/fullcalendar-5.3.2/lib/main.css' rel='stylesheet' />
    <script src='/fullcalendar-5.3.2/lib/main.js'></script>

    <div id="calendarApp">
        <div class="d-flex align-items-center mb-2">
            <h4 class="font-weight-bold m-0 font-size-16">
                Appointments for patient {{ $patient->displayName() }}
            </h4>
            <div class="ml-auto">
                <label class="mr-2 my-0 text-secondary">Show appointments in</label>
                <select id="eventTz" name="timeZone"
                        class="form-control form-control-sm"
                        v-model="timezone">
                    <option value="EASTERN" selected>Eastern</option>
                    <option value="CENTRAL">Central</option>
                    <option value="MOUNTAIN">Mountain</option>
                    <option value="PACIFIC">Pacific</option>
                    <option value="ALASKA">Alaska</option>
                    <option value="HAWAII">Hawaii</option>
                    <option value="PUERTO_RICO">Puerto Rico</option>
                </select>
            </div>
        </div>
        <div class="d-block appt-form">
            <form class="appt-form-col w-100 d-flex align-items-center mb-2">
                <label class="mr-2 my-0 text-secondary text-nowrap">Show appointments by</label>
                <select id="eventPros" name="proUid"
                        class="form-control form-control-sm flex-grow-1" multiple
                        v-model="proIds">
                    <?php
                    $proIndex = 0;
                    $proMeta = [];
                    ?>
                    @foreach($pros as $iPro)
                        <option value="{{$iPro->id}}"
                                data-bc="{{$palette[$proIndex]["bc"]}}"
                                data-fc="{{$palette[$proIndex]["fc"]}}"
                                data-initials="{{$iPro->initials()}}">
                            {{$iPro->displayName()}}
                        </option>
                        <?php
                        $proMeta[$iPro->uid] = [
                            "bc" => $palette[$proIndex]["bc"],
                            "fc" => $palette[$proIndex]["fc"],
                            "initials" => $iPro->initials()
                        ];
                        $proIndex++;
                        if($proIndex >= count($palette)) $proIndex = 0;
                        ?>
                    @endforeach
                </select>
            </form>
            <hr class="my-2">
            <div class="appt-calendar-col">
                <div class="stag-fc-container">

                </div>
            </div>
        </div>
    </div>
    <script>
        (function() {

            function init() {
                window.calendarApp = new Vue({
                    el: '#calendarApp',
                    data: {
                        calendar: null,
                        proMeta: {!! json_encode($proMeta) !!},
                        proIds: ['{{ $pro->id }}'],
                        timezone: 'EASTERN',
                        clickedDate: null,
                    },
                    methods: {
                        // init
                        init: function() {
                            this.initSelect2();
                            this.initCalendar();
                        },
                        initSelect2: function () {
                            let self = this;
                            $('#eventTz')
                                .select2({
                                    templateResult: function(_state) {
                                        return $('<span class="mcp-theme-1"><span>' + _state.text + '</span></span>');
                                    }
                                })
                                .on('change', function() {
                                    self.timezone = $(this).val();
                                    self.refreshEvents();
                                });
                            $('#eventPros')
                                .select2({
                                    closeOnSelect: false,

                                    // dropdown options
                                    templateResult: function(_state) {
                                        let element = _state.element;
                                        if(!element || !element.value) {
                                            return $('<span class="mcp-theme-1"><span>' + _state.text + '</span></span>');
                                        }
                                        element = $(element);
                                        return $('<span class="mcp-theme-1 pro-option" ' +
                                            'data-initials="' + element.attr('data-initials') + '" ' +
                                            'data-bc="' + element.attr('data-bc') + '" ' +
                                            'data-fc="' + element.attr('data-fc') + '"><span>' +
                                            '<span class="pro-option-initials" ' +
                                            'style="background: ' + element.attr('data-bc') + '; color: ' + element.attr('data-fc') + '">' +
                                            element.attr('data-initials') + '</span>' +
                                            _state.text +
                                            '</span></span>');
                                    },

                                    // selected items
                                    templateSelection: function(_state) {
                                        let element = _state.element;
                                        if(!element || !element.value) {
                                            return $('<span class="mcp-theme-1"><span>' + _state.text + '</span></span>');
                                        }
                                        element = $(element);
                                        return $('<span class="pro-selection" style="background: ' + element.attr('data-bc') + '; color: ' + element.attr('data-fc') + '">' +
                                            _state.text + '</span>');
                                    }
                                })
                                .on('change', function() {
                                    self.proIds = $(this).val();
                                    self.refreshEvents();
                                });
                        },
                        initCalendar: function () {
                            let self = this;
                            this.calendar = new FullCalendar.Calendar($('.stag-fc-container')[0], {
                                headerToolbar: {
                                    left: 'prev,next today',
                                    center: 'title',
                                    right: 'dayGridMonth,timeGridWeek,timeGridDay'
                                },
                                initialDate: '{{ date('Y-m-d') }}',
                                editable: true,
                                navLinks: true,
                                dayMaxEvents: false,
                                events: function(info, successCallback, failureCallback) {
                                    if(!self.proIds || !self.proIds.length) {
                                        successCallback([]); // no events if no pro selected
                                        return;
                                    }
                                    if(!self.timezone) {
                                        successCallback([]); // no events if no tz selected
                                        return;
                                    }
                                    $.get('/appointment/getAllAppointmentsForPros' +
                                        '?proIds=' + self.proIds +
                                        '&start=' + info.startStr.substr(0, 10) +
                                        '&end=' + info.endStr.substr(0, 10) +
                                        '&timeZone=' + self.timezone, function(_data) {
                                        // $.get('/api/appointment/getAllAppointmentsForPro?start=1990-01-01&end=2025-01-01&timeZone=CENTRAL', function(_data) {
                                        if(_data && Array.isArray(_data)) {
                                            let events = _data;
                                            for(let e in events) {
                                                if(events.hasOwnProperty(e) && self.proMeta[events[e].proUid]) {
                                                    let ev = events[e], meta = self.proMeta[ev.proUid];
                                                    ev.backgroundColor =  meta.bc;
                                                    ev.borderColor = meta.bc;
                                                    ev.textColor = meta.fc;
                                                    ev.initials = meta.initials;
                                                    ev.display = 'block';
                                                }
                                            }
                                            successCallback(events);
                                        }
                                        else {
                                            failureCallback(_data);
                                        }
                                    }, 'json');
                                },
                                loading: function(bool) {

                                },
                                dateClick: function(info) {
                                    this.clickedDate = {
                                        allDay: info.allDay,
                                        date: info.date,
                                        dateStr: info.dateStr,
                                        dayEl: info.dayEl,
                                    };
                                    $('.appt-form td.stag-selected').removeClass('stag-selected');
                                    $(info.dayEl).addClass('stag-selected');
                                },
                                eventDrop: self.eventMovedOrResized,
                                eventResize: self.eventMovedOrResized
                            });
                            this.calendar.render();
                        },
                        eventMovedOrResized: function (info) {
                            let date = info.event.start.getFullYear() + "-" +
                                ("0"+(info.event.start.getMonth()+1)).slice(-2) + "-" +
                                ("0" + info.event.start.getDate()).slice(-2);
                            let startTime = ("0" + info.event.start.getHours()).slice(-2) + ":" +
                                ("0" + info.event.start.getMinutes()).slice(-2);
                            let endTime = null;
                            if(info.event.end) {
                                endTime = ("0" + info.event.end.getHours()).slice(-2) + ":" +
                                    ("0" + info.event.end.getMinutes()).slice(-2);
                            }
                            $.post('/api/appointment/updateDateAndTime', {
                                uid: info.event.extendedProps.appointmentUid,
                                date: date,
                                startTime: startTime,
                                endTime: endTime,
                                timeZone: this.timezone,
                            }, function(_data) {
                                console.log(_data)
                            }, 'json');
                        },
                        refreshEvents: function() {
                            this.calendar.refetchEvents();
                        }
                    },
                    mounted: function() {
                        this.init();
                    }
                });
            }

            addMCInitializer('patient-calendar', init);
        })();
    </script>
@endsection
